// MoeMesto Toolbar   www.moemesto.ru

function mm_add_error_menu(top,msg,url) {
	mm_dump('enter mm_add_error_menu msg:' + msg);
	
	var subPop = document.createElement("menupopup");

	var tempItem = document.createElement("menuitem");
	tempItem.setAttribute("label", msg );
	tempItem.setAttribute("tooltiptext", "" );
	if( url ) {
		tempItem.setAttribute("oncommand", "open_mm('"+url+"'); event.stopPropagation();" );
		}
	subPop.appendChild(tempItem);	

	var tempItem = document.createElement("menuseparator");
	subPop.appendChild(tempItem);	

	var tempItem = document.createElement("menuitem");
	tempItem.setAttribute("label", mm_msg('renew') );
//	tempItem.setAttribute("label", 'Обновить' );	
	tempItem.setAttribute("tooltiptext", "" );
	tempItem.setAttribute("image", "chrome://moemesto/skin/reload.png" );
	tempItem.setAttribute("oncommand", "mm_sync(1); event.stopPropagation();" );
	subPop.appendChild(tempItem);
	
	DeleteChildren(top);
	top.appendChild(subPop);	
	return top;
	}


function mm_add_links_menu(top,menu) {
//	mm_dump('enter mm_add_links_menu');	
	var subPop = document.createElement("menupopup");

	for( i in menu ) {
		if( menu[i].menu ) {
			var tempItem = document.createElement("menu");
			tempItem.setAttribute("label", i);
			tempItem.setAttribute("tooltiptext", "");		
			mm_add_links_menu(tempItem,menu[i].menu);
			}
		else {
			var tempItem = document.createElement("menuitem");
			tempItem.setAttribute("label", menu[i].t);
			tempItem.setAttribute("oncommand", "open_url('"+menu[i].u+"'); event.stopPropagation();" );
			if( menu[i].d ) { tempItem.setAttribute("tooltiptext", menu[i].d); }
			}
		subPop.appendChild(tempItem);			
		}
	
	DeleteChildren(top);
	top.appendChild(subPop);	
	return top;
	}


function mm_add_up_menu(top,menu) {
	mm_dump('enter mm_add_up_menu');
	var subPop = document.createElement("menupopup");

	for( i in menu ) {
		var tempItem = document.createElement("menu");
		tempItem.setAttribute("label", i);
		tempItem.setAttribute("tooltiptext", "" );
		mm_add_links_menu(tempItem,menu[i].links);
		subPop.appendChild(tempItem);
		}
	
	DeleteChildren(top);
	top.appendChild(subPop);	
	return top;
	}


function update_sub_links(id, links) {
	mm_dump('enter update_sub_links '+id);
	if( !links ) { return ''; }
	if( links.id != id ) { return ''; }	
	
	var subMenu = document.getElementById('mm_menu_'+id);
	if( !subMenu ) {
		mm_dump('can not get ID mm_menu_'+id);
		return '';
		}

	if( links.error != 0 ) 	{ mm_add_error_menu(subMenu,links.msg,links.error_url); } 
	else 	{
		if( links.links ) { mm_add_links_menu(subMenu,links.links); }
		else if( links.menu ) { mm_add_up_menu(subMenu,links.menu); }
		else { mm_dump('no links or menu in '+ id); }
		}		

	return 1;
	}


function hide_start() {
	var start = document.getElementById('mm_menu_start');
	if( !start ) { return ''; }
	DeleteChildren(start);
	start.setAttribute("hidden", "true" );		
	var separator = document.getElementById('mm_menu_start_separator');
	if( separator ) { separator.parentNode.removeChild(separator); }	
	}

function update_start(res) {
	mm_dump('enter update_start ');
	if( !res ) { return ''; }
	if( !res.start ) { hide_start(); return ''; }	
	if( res.start_category ) { 
		links = res.cats_links;
		if( !links ) { mm_dump('update_start: no cats_links in response'); return ''; }
		links = links.menu[ res.start_category ];
		if( !links ) { mm_dump('update_start: no category '+res.start_category+' in response'); return ''; }
		}
	else if( res.start_links ) { 		
		links = res.start_links;
		if( !links ) { mm_dump('update_start: no start_links in response'); return ''; }		
		}
	else {
		hide_start(); return '';
		}
	
	var subMenu = document.getElementById('mm_menu_start');
	if( !subMenu ) {
		mm_dump('can not get ID mm_menu_start');
		return '';
		}
	
	subMenu.setAttribute("hidden", "false" );		
	
	if( !document.getElementById('mm_menu_start_separator') ) {
		var tempItem = document.createElement("menuseparator");
		tempItem.setAttribute('id','mm_menu_start_separator');
		subMenu.parentNode.insertBefore(tempItem, subMenu.nextSibling);
		}
	
	if( links.links ) { mm_add_links_menu(subMenu,links.links); }
	else if( links.menu ) { mm_add_up_menu(subMenu,links.menu); }
	else { mm_dump('no links or menu in '+res.start_category); }

	return 1;
	}


function init_db() {
	mm_dump('enter init_db');

	var res = load_db(MM_DB_FILE);		
	if( res.length > 3 ) { 
		var r = MJSON.fromString(res);
		if( !r ) { mm_dump('not valid JSON db'); return 0; }
		if( r.version !== MM_DB_VERSION ) { 
			mm_dump('Wrong db vesrion '+r.version+', required '+MM_DB_VERSION);
			return 0;
			}
		
		update_sub_links('my_links', r.my_links);				
		update_sub_links('cats_links', r.cats_links);				
		update_sub_links('ftags_links', r.ftags_links);				
		
		update_start(r);
		
		mm_login = get_mm_login();
		mm_dump("mm_login: "+mm_login+", db_login: "+r.login);
		if( mm_login && r.login && mm_login != r.login ) {
			mm_dump('sync new user '+mm_login+' (old user '+r.login+')');
			mm_sync();
			}

		if( MM_DB_AUTO_UPDATE ) {					
			date = new Date();
			curr = date.getTime()/1000;
			curr = curr.toFixed(0);
			mm_dump('mm date: '+r.date+' current: '+curr);
			if( curr-r.date > MM_SYNC_INTERVAL ) {
				mm_dump('sync old db, mm date: '+r.date+' current: '+curr);
				mm_sync();
				}
			}
		}
	else { mm_sync(); }
		
	return 1;
	}


function init_opts() {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	prefs = prefs.getBranch("extensions.moemesto.");
	return prefs;
	}
	
function save_links (links) {
	var prefs = init_opts();
	
	prefs.setCharPref("links.test", 'qwe123');
	str.data = 'Костя';
	prefs.setComplexValue("links.uni", Components.interfaces.nsISupportsString, str);
//	var t1 = prefs.getCharPref("links.test");
	}	


function sync_handle (response, fargs) {
	mm_dump('enter sync_handle');

	if( response.length < 3 ) { 
		mm_dump('no response from '+ MM_SYNC_URL);
		return 0;
		}
		
	var r = MJSON.fromString(response);
	if( !r ) {
		alert('not valid JSON response from '+ MM_SYNC_URL);
		return 0;
		}
	
	if( r.error == undefined ) {
		alert('wrong response structure from '+ MM_SYNC_URL);
		return 0;
		}

	mm_dump('ver: '+r.version);		
	if( r.version !== MM_DB_VERSION ) {
		alert(mm_msg('protocol_error'));
		open_mm('help/firefox.html');
		return 0;
		}		
		
	if( fargs.verbose ) {
		if( r.error == 1 ) {
			alert(r.msg+'. '+mm_msg('auth_error'));
			open_mm('login/');
			return 0;
			}
		}	
	
	update_sub_links('my_links', r.my_links);					
	update_sub_links('cats_links', r.cats_links);					
	update_sub_links('ftags_links', r.ftags_links);					
	
	update_start(r);
	
	var sv = MJSON.toString(r);
	save_db(MM_DB_FILE,sv);		
	
	return 1;
	}

function mm_sync(v) {
	set_HtRequest( MM_SYNC_URL, '', sync_handle, {verbose:v} );
	}


function get_mm_login() {
	var login = '';
	
	cookiemanager = Components.classes["@mozilla.org/cookiemanager;1"].getService();
	cookiemanager = cookiemanager.QueryInterface(Components.interfaces.nsICookieManager);  

	var enumerator = cookiemanager.enumerator;
	while (enumerator.hasMoreElements())
	{
		var nextCookie = enumerator.getNext();
		if (!nextCookie) break;
		nextCookie = nextCookie.QueryInterface(Components.interfaces.nsICookie);

		if ( ( nextCookie.host == "www."+MM_SITE || 
		     nextCookie.host == MM_SITE ) &&
		     nextCookie.name == "mmUser" )	{			
			var n = nextCookie.value.indexOf( "%" );
			if ( n != -1 ) {
				login = nextCookie.value.substr( 0, n );
				}
		 	}
	}

	return login;
}



function getSelectedText(charlen) {
	mm_dump('enter getSelectedText');
   
	var focusedWindow = document.commandDispatcher.focusedWindow;
	var searchStr = focusedWindow.getSelection();      
	searchStr = searchStr.toString();
       
	var originalSearchStrLength = searchStr.length;

	if (!charlen) { charlen = 2800; }
	if (charlen < searchStr.length) {
          var pattern = new RegExp("^(?:\\s*.){0," + charlen + "}");
          pattern.test(searchStr);
          searchStr = RegExp.lastMatch;
       }
      
	searchStr = searchStr.replace(/^\s+/, "");
	searchStr = searchStr.replace(/\s+$/, "");
	searchStr = searchStr.replace(/\s+/g, " ");
       
	searchStr = searchStr.substr(0,charlen);

	mm_dump('getSelectedText limit: '+charlen+' len: '+searchStr.length);
    
	return searchStr;
	}

function get_mm_url() {
	var url = '';
	var login = get_mm_login();
	if( login.length == 0 ) { 
		url = MM_HOME_URL + '/login/';
		}
	else {
		url = MM_HOME_URL + '/' + login + '/';
		}
	return url;
	}


function mm_my(type) {
	var login = get_mm_login();
	if( login.length == 0 ) { 
		window._content.document.location = MM_HOME_URL + '/login/';
		return; 
		}

	var mm_url = MM_HOME_URL + '/' + login + '/';
	
	if( type == 'all' ) { url = mm_url + 'all/'; }
	else if( type == 'notes' ) { url = mm_url + 'notes/'; }
	else if( type == 'files' ) { url = mm_url + 'files/'; }
	else if( type == 'tags' ) { url = mm_url + 'tag/'; }	
	else if( type == 'cats' ) { url = mm_url + 'cat/'; }	
	else if( type == 'ftags' ) { url = mm_url + 'ftags/'; }	
	
	window._content.document.location = url;
	}


function mm_tab(event) {
	if( event.button == 1 ) {
		var mm_url = get_mm_url();
		var browser = document.getElementById("content");	
		var tab = browser.addTab(mm_url);
		browser.selectedTab = tab;
		}
}


function mm_main() {
	var mm_url = get_mm_url();
	window._content.document.location = mm_url;
}

function open_url(url) {
	window._content.document.location = url;
}

function open_mm(url) {
	window._content.document.location = MM_HOME_URL + url;
}


function mm_add_url() {
	var url = MM_HOME_URL + "/post/" + MM_VERSION + "/?url=" + 
		encodeURIComponent(window._content.document.location) + 
		"&title=" + encodeURIComponent( document.title.replace(" - Mozilla Firefox","") );	

	var notes = getSelectedText();
	if( notes.length > 2 ) {
		url += "&desc=" + encodeURIComponent(notes);
		}
	
	window._content.document.location = url;
}

function mm_upload() {
	window._content.document.location = MM_HOME_URL + "/upload/" + MM_VERSION + "/";
	}

function mm_add_image() {
	var address = gContextMenu.imageURL||gContextMenu.mediaURL;
	var url = MM_HOME_URL + "/upload/url/" + MM_VERSION + "/?url=" + encodeURIComponent(address);
	var notes = getSelectedText();
	if( notes.length > 2 ) {
		url += "&desc=" + encodeURIComponent(notes);
		}
	
	window._content.document.location = url;
}


function mm_add_note() {
	var url = MM_HOME_URL + '/note/' + MM_VERSION + '/'; 
	var notes = getSelectedText();
	
	if( notes.length > 2 ) { url += '?desc=' + encodeURIComponent(notes); }
	window._content.document.location = url;
}

function mm_context(e) {
	if (!gContextMenu) { return; }
	var needToHide = (!gContextMenu.onImage);
	document.getElementById('mm_add_image').hidden = needToHide;
	}

function mm_init_image() {
	var contextmenu = document.getElementById("contentAreaContextMenu");
	if (contextmenu) { contextmenu.addEventListener("popupshowing",mm_context,false); }
	}

function mm_init(event) { mm_init_locale(); init_db(); mm_init_image(); }
	
window.addEventListener("load", mm_init, false);
  
